=== debian/changelog ===
frobby (0.9.6-1~exp1) experimental; urgency=medium

  * New upstream release.
    - API change; constants::version is now frobby_version.  (This actually
      occurred in 0.9.5, but without a soversion bump, so we patched it
      back to the old behavior in Debian.)
  * Rename libfrobby0 binary package to libfrobby1 due to soversion bump.
  * Upload to experimental ahead of libfrobby0 -> libfrobby1 transition.
  * debian/control
    - Update my email address; now a Debian Developer.
    - Bump Standards-Version to 4.7.2
    - Drop dependency on g++; we only had it to guarantee GCC at least 7,
      but GCC 10 is now in oldoldstable.
    - Remove redundant Rules-Requires-Root field.
  * debian/copyright
    - Update my copyright years and email address.
  * debian/frobby.manpages
    - Update path to manpage.
  * debian/gbp.conf
    - New file; set debian-branch to debian/latest and pristine-tar to True.
  * debian/libfrobby*.install
    - Update paths now that dh_auto_install installs everything in the
      proper place.
  * debian/patches/frobby-version.patch
    - Remove patch; no longer necessary since upstream has properly bumped
      the soversion.
  * debian/rules
    - Drop override_dh_link target as shared library symlinks are now created
      by the upstream Makefile.
    - Stop setting RANLIB variable; now set in upstream Makefile.
    - Stop setting library name and soname; now taken care of in upstream
      Makefile.
    - Stop setting BIN_INSTALL_DIR; no longer used;
    - Export PREFIX and LIBDIR so that dh_auto_install will install
      everything in the right places.
  * debian/tests/frobby-version.cpp
    - Update to use frobby_version.

 -- Doug Torrance <dtorrance@debian.org>  Mon, 22 Dec 2025 11:21:43 -0500
