=== Makefile ===
--- 
+++ 
@@ -15,7 +15,7 @@
 # bump if interfaces added, removed, or changed
 FROBBY_CURRENT = 1
 # bump at every release, set to 0 if any interfaces added, removed, or changed
-FROBBY_REVISION = 1
+FROBBY_REVISION = 2
 # bump if interfaces added, set to 0 if removed or changed
 FROBBY_AGE = 0
 FROBBY_SOVERSION := $(shell expr $(FROBBY_CURRENT) - $(FROBBY_AGE))
@@ -86,6 +86,9 @@
 ifndef CXX
   CXX      = "g++"
 endif
+ifndef STRIP
+  STRIP    = strip
+endif
 
 cxxflags = $(CXXFLAGS) $(CPPFLAGS) -I $(GMP_INC_DIR) -Wno-uninitialized -Wno-unused-parameter
 program = frobby
@@ -223,7 +226,7 @@
 	fi
 endif
 ifeq ($(MODE), release)
-	strip $@
+	$(STRIP) $@
 endif
 
 # Link object files into library
@@ -263,6 +266,7 @@
 BINDIR ?= $(PREFIX)/bin
 MAN1DIR ?= $(PREFIX)/share/man/man1
 LIBDIR ?= $(PREFIX)/lib
+INCLUDEDIR ?= $(PREFIX)/include
 
 # Installation.
 install:
@@ -274,6 +278,8 @@
 endif
 ifneq ($(wildcard bin/libfrobby*),)
 	install -d $(DESTDIR)$(LIBDIR)
+	install -d $(DESTDIR)$(INCLUDEDIR)
+	install src/frobby.h $(DESTDIR)$(INCLUDEDIR)
 ifneq ($(wildcard bin/libfrobby.a),)
 	install bin/libfrobby.a $(DESTDIR)$(LIBDIR)
 endif
@@ -324,11 +330,3 @@
 develDocPs: bin/develDoc/
 	rm -rf bin/develDoc/latexPs bin/develDoc/warningLog
 	cat doc/doxygen.conf doc/doxPs|doxygen -
-	cd bin/develDoc/latexPs/; make refman.ps; mv refman.ps ../develDoc.ps
-
-clean: tidy
-	rm -rf bin
-
-# ***** Miscellaneous
-
-tidy:
