=== debian/changelog ===
frobby (0.9.7-1) unstable; urgency=medium

  * New upstream release.

  [ Helmut Grohne ]
  * Fix FTCBFS: (Closes: #1125147)
    + Let dh_auto_build pass cross tools to make.
    + Don't strip during build.

  [ Doug Torrance ]
  * debian/copyright
    - Update my copyright years.
  * debian/libfrobby-dev.install
    - Simplify installation of header file now that upstream installs it
      for us.

 -- Doug Torrance <dtorrance@debian.org>  Fri, 09 Jan 2026 15:07:27 -0500

frobby (0.9.6-1) unstable; urgency=medium

  * Upload to unstable for libfrobby0 -> libfrobby1 transition.
  * debian/control
    - Drop Priority field; "optional" is now the default.
    - Bump Standards-Version to 4.7.3.

 -- Doug Torrance <dtorrance@debian.org>  Sun, 28 Dec 2025 07:37:53 -0500
