=== debian/control ===
--- 
+++ 
@@ -2,11 +2,10 @@
 Maintainer: Debian Math Team <team+math@tracker.debian.org>
 Uploaders: Doug Torrance <dtorrance@debian.org>
 Section: math
-Priority: optional
 Build-Depends: debhelper-compat (= 13)
 Build-Depends-Arch: libgmp-dev, texlive-latex-base
 Build-Depends-Indep: doxygen
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/math-team/frobby
 Vcs-Git: https://salsa.debian.org/math-team/frobby.git
 Homepage: https://github.com/Macaulay2/frobby
