=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk # for DEB_HOST_MULTIARCH

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export PREFIX = /usr
export LIBDIR = /usr/lib/$(DEB_HOST_MULTIARCH)

# for reproducible builds of manual
export FORCE_SOURCE_DATE = 1

%:
	dh $@ --no-parallel --buildsystem=makefile

override_dh_auto_build-arch:
	dh_auto_build -- all STRIP=:
	dh_auto_build -- library
	dh_auto_build -- library MODE=shared
	dh_auto_build -- docPdf

override_dh_auto_build-indep:
	dh_auto_build -- develDocHtml

override_dh_auto_test-indep override_dh_auto_install-indep:

override_dh_installdocs:
	dh_installdocs -X/_formulas.
